/**
 * link-local-dependencies
 * Install local lerna dependencies
 */
import * as TE from 'fp-ts/TaskEither';
import { FindPackageError } from '@typescript-tools/find-package';
import { PackageManifestsError } from '@typescript-tools/package-manifests';
import { PackageDiscoveryError } from '@typescript-tools/lerna-packages';
export declare type LinkLocalDependenciesError = FindPackageError | PackageDiscoveryError | PackageManifestsError | {
    type: 'unable to decode package manifest';
    error: string;
} | {
    type: 'unable to create directory';
    path: string;
    error: Error;
} | {
    type: 'unable to create symlink';
    target: string;
    path: string;
    error: Error;
};
export declare const linkLocalDependencies: (packagePathOrName: string) => TE.TaskEither<LinkLocalDependenciesError, void>;
//# sourceMappingURL=index.d.ts.map